USE [InternalStorageFormat]
GO
if exists (select * from sysobjects where id =  object_id(N'[dbo].[Customers]') and OBJECTPROPERTY(id, N'IsUserTable') = 1 )
DROP TABLE dbo.Customers

CREATE TABLE Customers
(
   FirstName CHAR(50) NOT NULL,
   LastName CHAR(50) NOT NULL,
   Address CHAR(100) NOT NULL,
   ZipCode CHAR(5) NOT NULL,
   Rating INT NOT NULL,
   ModifiedDate DATETIME NOT NULL,
)
GO


INSERT INTO dbo.Customers
        ( FirstName ,
          LastName ,
          Address ,
          ZipCode ,
          Rating ,
          ModifiedDate
        )
VALUES  ( 'Philip' , -- FirstName - char(50)
          'Aschenbrenner' , -- LastName - char(50)
          'Pichlagasse 16/6' , -- Address - char(50)
          '1220' , -- ZipCode - char(5)
          1 , -- Rating - int
          '2015-03-25 02:22:51'  -- ModifiedDate - datetime
        )
        go 2
        
--DBCC IND ڲѯһ洢ڲ洢ṹϢ4, ǰ3ָ﷨£
--DBCC IND ( { 'dbname' | dbid }, { 'objname' | objid },{ nonclustered indid | 1 | 0 | -1 | -2 } [, partition_number] )
--һݿݿID
--ڶݿеĶIDǱͼ
--һǾۼID 1, 0, 1, or 2. ֵĺ壺
-- 0: ֻʾin-row dataҳ in-row IAM ҳ
-- 1: ʾȫҳ, IAM ҳ, in-rowҳ, LOB ҳrow-overflow ҳ . ĶоۼҳҲ
-- -1: ʾȫIAMҳ,ҳ, ҳ Ҳ LOB row-overflow ҳ
-- -2: ʾȫIAMҳ
-- Nonclustered index ID:ʾȫ IAMҳ, dataҳҳLOB row-overflowҳ
--Ϊ˼sql server 2000,ĸǿѡ,òָһ.ֵ߸0, ʾȫݡ
--DBCC PAGEͬ, SQL ServerDBCC INDҪ3604ٱ־.
DBCC IND('InternalStorageFormat','Customers',-1)
--Page type: 1 = data page, 2 = index page, 3 = LOB_MIXED_PAGE, 4 = LOB_TREE_PAGE, 10 = IAM page    

--dbcc page ȡҳṹDBCC Page
--Ϊĵ£ 
--DBCC Page ({dbid|dbname},filenum,pagenum[,printopt])
--£
--dbid ҳݿID
--dbname ҳݿ
--filenum ҳļ
--pagenum ļڵҳ
--printopt ѡѡ;ѡһֵ
--0:Ĭֵıҳ
--1:ı⡢ҳ(ֱÿһ)Լƫ
--2:ı⡢ҳ(ҳ)Լƫ
--3:ı⡢ҳ(ֱÿһ)Լƫ;ÿһ
--ֱгֵ
--Ҫ뿴ЩĽҪDBCC TRACEON(3604)

DBCC TRACEON(3604)
DBCC PAGE(InternalStorageFormat,1,80,1)
GO    


SELECT * FROM sys.dm_os_buffer_descriptors
--free_space_in_bytes ʾָҳ浱ǰжٿռǿõġ


--ѯԸݿʵÿжٿռ䱻˷ѣ
--ҳĸݿıơ

SELECT
DB_NAME(database_id),
SUM(free_space_in_bytes) / 1024 AS 'Free_KB'
FROM sys.dm_os_buffer_descriptors
WHERE database_id <> 32767
GROUP BY database_id
ORDER BY SUM(free_space_in_bytes) DESC
GO
